Asterisk.org: Developer Documentation (28 Oct 2009)

Wed Oct 28 15:49:25 2009

## Asterisk developer's documentation

# ao2_container Struct Reference

## Data Fields

struct bucket | buckets [0]
ao2_callback_fn | cmp_fn
int | elements
ao2_hash_fn | hash_fn
int | n_buckets
int | version

## Detailed Description

A container; stores the hash and callback functions, information on the size, the hash bucket heads, and a version number, starting at 0 (for a newly created, empty container) and incremented every time an object is inserted or deleted. The assumption is that an object is never moved in a container, but removed and readded with the new number. The version number is especially useful when implementing iterators. In fact, we can associate a unique, monotonically increasing number to each object, which means that, within an iterator, we can store the version number of the current object, and easily look for the next one, which is the next one in the list with a higher number. Since all objects have a version >0, we can use 0 as a marker for 'we need the first object in the bucket'.

Todo:
  Linking and unlink objects is typically expensive, as it involves a malloc() of a small object which is very inefficient. To optimize this, we allocate larger arrays of bucket_list's when we run out of them, and then manage our own freelist. This will be more efficient as we can do the freelist management while we hold the lock (that we need anyways).

Definition at line 267 of file astobj2.c.

## Field Documentation

struct bucket buckets[0]`[read]`

variable size

Definition at line 276 of file astobj2.c.

Referenced by __ao2_link(), ao2_callback(), and ao2_iterator_next().

ao2_callback_fn cmp_fn

Definition at line 269 of file astobj2.c.

Referenced by ao2_container_alloc(), and ao2_find().

int elements

Number of elements in the container

Definition at line 272 of file astobj2.c.

Referenced by __ao2_link(), ao2_callback(), and ao2_container_count().

ao2_hash_fn hash_fn

Definition at line 268 of file astobj2.c.

Referenced by __ao2_link(), ao2_callback(), and ao2_container_alloc().

int n_buckets

Definition at line 270 of file astobj2.c.

Referenced by __ao2_link(), ao2_callback(), ao2_container_alloc(), and ao2_iterator_next().

int version

described above

Definition at line 274 of file astobj2.c.

Referenced by __ao2_link(), ao2_callback(), ao2_container_alloc(), and ao2_iterator_next().

The documentation for this struct was generated from the following file:

- astobj2.c